/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Apache Antタスク [BlancoSed]のクラス
 */
package blanco.sed.task;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import blanco.sed.task.valueobject.BlancoSedProcessInput;

/**
 * Apache Antタスク [BlancoSed]のクラス。
 *
 * sedを実行するためのAntTaskです。<br>
 * このクラスでは、Apache Antタスクで一般的に必要なチェックなどのコーディングを肩代わりします。
 * 実際の処理は パッケージ[blanco.sed.task]にBlancoSedBatchProcessクラスを作成して記述してください。<br>
 * <br>
 * Antタスクへの組み込み例<br>
 * <pre>
 * &lt;taskdef name=&quot;blancosed&quot; classname=&quot;blanco.sed.task.BlancoSedTask">
 *     &lt;classpath&gt;
 *         &lt;fileset dir=&quot;lib&quot; includes=&quot;*.jar&quot; /&gt;
 *         &lt;fileset dir=&quot;lib.ant&quot; includes=&quot;*.jar&quot; /&gt;
 *     &lt;/classpath&gt;
 * &lt;/taskdef&gt;
 * </pre>
 */
public class BlancoSedTask extends Task {
    /**
     * sedを実行するためのAntTaskです。
     */
    protected BlancoSedProcessInput fInput = new BlancoSedProcessInput();

    /**
     * sedを実行するためのAntTaskです。
     */
    protected boolean fIsFieldInputProcessed = false;

    /**
     * sedを実行するためのAntTaskです。
     */
    protected boolean fIsFieldOutputProcessed = false;

    /**
     * sedを実行するためのAntTaskです。
     */
    protected boolean fIsFieldScriptProcessed = false;

    /**
     * sedを実行するためのAntTaskです。
     */
    protected boolean fIsFieldScriptfileProcessed = false;

    /**
     * sedを実行するためのAntTaskです。
     */
    protected boolean fIsFieldEncodingProcessed = false;

    /**
     * verboseモードで動作させるかどうか。
     *
     * @param arg verboseモードで動作させるかどうか。
     */
    public void setVerbose(final boolean arg) {
        fInput.setVerbose(arg);
    }

    /**
     * verboseモードで動作させるかどうか。
     *
     * @return verboseモードで動作させるかどうか。
     */
    public boolean getVerbose() {
        return fInput.getVerbose();
    }

    /**
     * Antタスクの[input]アトリビュートのセッターメソッド。
     *
     * 項目番号: 1<br>
     * 入力ファイルを指定します。<br>
     *
     * @param arg セットしたい値
     */
    public void setInput(final String arg) {
        fInput.setInput(arg);
        fIsFieldInputProcessed = true;
    }

    /**
     * Antタスクの[input]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 1<br>
     * 入力ファイルを指定します。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getInput() {
        return fInput.getInput();
    }

    /**
     * Antタスクの[output]アトリビュートのセッターメソッド。
     *
     * 項目番号: 2<br>
     * 出力ファイルを指定します。<br>
     *
     * @param arg セットしたい値
     */
    public void setOutput(final String arg) {
        fInput.setOutput(arg);
        fIsFieldOutputProcessed = true;
    }

    /**
     * Antタスクの[output]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 2<br>
     * 出力ファイルを指定します。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getOutput() {
        return fInput.getOutput();
    }

    /**
     * Antタスクの[script]アトリビュートのセッターメソッド。
     *
     * 項目番号: 3<br>
     * スクリプトを指定します。<br>
     *
     * @param arg セットしたい値
     */
    public void setScript(final String arg) {
        fInput.setScript(arg);
        fIsFieldScriptProcessed = true;
    }

    /**
     * Antタスクの[script]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 3<br>
     * スクリプトを指定します。<br>
     *
     * @return このフィールドの値
     */
    public String getScript() {
        return fInput.getScript();
    }

    /**
     * Antタスクの[scriptfile]アトリビュートのセッターメソッド。
     *
     * 項目番号: 4<br>
     * スクリプトファイルを指定します。<br>
     *
     * @param arg セットしたい値
     */
    public void setScriptfile(final String arg) {
        fInput.setScriptfile(arg);
        fIsFieldScriptfileProcessed = true;
    }

    /**
     * Antタスクの[scriptfile]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 4<br>
     * スクリプトファイルを指定します。<br>
     *
     * @return このフィールドの値
     */
    public String getScriptfile() {
        return fInput.getScriptfile();
    }

    /**
     * Antタスクの[encoding]アトリビュートのセッターメソッド。
     *
     * 項目番号: 5<br>
     * ファイルのエンコードを指定します。<br>
     *
     * @param arg セットしたい値
     */
    public void setEncoding(final String arg) {
        fInput.setEncoding(arg);
        fIsFieldEncodingProcessed = true;
    }

    /**
     * Antタスクの[encoding]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 5<br>
     * ファイルのエンコードを指定します。<br>
     * デフォルト値[Windows-31J]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getEncoding() {
        return fInput.getEncoding();
    }

    /**
     * Antタスクのメイン処理。Apache Antから このメソッドが呼び出されます。
     *
     * @throws BuildException タスクとしての例外が発生した場合。
     */
    public final void execute() throws BuildException {
        System.out.println("BlancoSedTask begin.");

        // 項目番号[1]、アトリビュート[input]は必須入力です。入力チェックを行います。
        if (fIsFieldInputProcessed == false) {
            throw new BuildException("必須アトリビュート[input]が設定されていません。処理を中断します。");
        }
        // 項目番号[2]、アトリビュート[output]は必須入力です。入力チェックを行います。
        if (fIsFieldOutputProcessed == false) {
            throw new BuildException("必須アトリビュート[output]が設定されていません。処理を中断します。");
        }

        if (getVerbose()) {
            System.out.println("- verbose:[true]");
            System.out.println("- input:[" + getInput() + "]");
            System.out.println("- output:[" + getOutput() + "]");
            System.out.println("- script:[" + getScript() + "]");
            System.out.println("- scriptfile:[" + getScriptfile() + "]");
            System.out.println("- encoding:[" + getEncoding() + "]");
        }

        try {
            // 実際のAntタスクの主処理を実行します。
            // この箇所でコンパイルエラーが発生する場合、BlancoSedProcessインタフェースを実装して blanco.sed.taskパッケージに BlancoSedProcessImplクラスを作成することにより解決できる場合があります。
            final BlancoSedProcess proc = new BlancoSedProcessImpl();
            if (proc.execute(fInput) != BlancoSedBatchProcess.END_SUCCESS) {
                throw new BuildException("タスクは異常終了しました。");
            }
        } catch (IllegalArgumentException e) {
            if (getVerbose()) {
                e.printStackTrace();
            }
            throw new BuildException(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中に例外が発生しました。処理を中断します。" + e.toString());
        } catch (Error e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中にエラーが発生しました。処理を中断します。" + e.toString());
        }
    }
}
